#include <Keypad.h>
#include <LiquidCrystal_I2C.h>

int RedPin = A1;
int GreenPin = A2;
int BluePin = A3;

const byte ROWS = 4;
const byte COLS = 4;
char keys [ROWS] [COLS] = {
  {'1', '2', '3', 'A'},
  {'4', '5', '6', 'B'},
  {'7', '8', '9', 'C'},
  {'*', '0', '#', 'D'}
};
byte rowPins [ROWS] = {9, 8, 7, 6};
byte colPins [COLS] = {5, 4, 3, 2};
Keypad keypad = Keypad(makeKeymap(keys), rowPins, colPins, ROWS, COLS);

LiquidCrystal_I2C lcd(32,16,2);
int a = 0;
int MAX = 16;

int latchPin = 13;
int clockPin = 12;






void setup() {
  
  
  Wire.begin (); 
  Serial.begin(9600);
  lcd.init();
  lcd.clear();         
  lcd.backlight();
  
  
  pinMode(RedPin,INPUT);
  pinMode(GreenPin,INPUT);
  pinMode(BluePin,INPUT);  
  pinMode(latchPin,OUTPUT);
  pinMode(clockPin,OUTPUT);
  
  
  lcd.setCursor(0,0);
  lcd.print("No. Of People");
  int PEO = getKeypadInteger();
  lcd.clear();  
  
  lcd.setCursor(0,0);
  lcd.print("No. Of Imposters");
  int IM = getKeypadInteger();
   lcd.clear(); 
  
  lcd.setCursor(0,0);
  lcd.print("No. Of Police");
  int PO = getKeypadInteger();
   lcd.clear();
  
  lcd.setCursor(0,0);
  lcd.print("No. Of Docter");
  int DR = getKeypadInteger();
   lcd.clear();
  
  
  
  
  int List [MAX];
  int R [MAX];
  int G [MAX];
  int B [MAX];
  clr(List);
  clr(R);
  clr(G);
  clr(B);
  int CO = PEO - (IM + PO + DR);
  while (a < CO) {
    List[a] = 0;
    R [a] = 1;
    G [a] = 1;
    B [a] = 1;
    a = a + 1 ;
  }
  a = 0;
  while (a < IM) {
    List [a + CO] = 1;
    R [a + CO] = 1;
    G [a + CO] = 0;
    B [a + CO] = 0;
    a = a + 1;
  }
  a = 0;
  while (a < PO) {
    List [a + CO + IM] = 2;
    R [a + CO + IM] = 0;
    G [a + CO + IM] = 0;
    B [a + CO + IM] = 1;
    a = a + 1;
  }
  a = 0;
  while (a < DR) {
    List [a + CO + IM + PO] = 3;
    R [a + CO + IM + PO] = 0;
    G [a + CO + IM + PO] = 1;
    B [a + CO + IM + PO] = 0;
    a = a + 1;
  }
  
  
  
  
  randomSeed(analogRead(A0));
  for (int i = 0; i < PEO; i++) {
    int n = random(0, PEO);
    swap(List,n,i);
    swap(R,n,i);
    swap(G,n,i);
    swap(B,n,i);
  }
  printit(List, MAX);
  printit(R, MAX);
  printit(G, MAX);
  printit(B, MAX);
  
  
  
  
  long int Red = IDK(R);
  long int Green = IDK(G);
  long int Blue = IDK(B);
  Serial.println(Red);
  Serial.println(Green);
  Serial.println(Blue);
  
  shift(Red, RedPin);
  shift(Green, GreenPin);
  shift(Blue, BluePin);  
  
}
void loop() {
}

void shift(long int leds,int PIN){
   
  byte lowLED  = lowByte(leds);
  byte highLED = highByte(leds);
  
  digitalWrite(latchPin, LOW);      
  shiftOut(PIN, clockPin, LSBFIRST, highLED);
  shiftOut(PIN, clockPin, LSBFIRST, lowLED);    
  digitalWrite(latchPin, HIGH);
}

int getKeypadInteger()
{
  int value = 0;
  int keyval;
  int isnum;
  do
  {
    keyval = keypad.getKey();
    isnum = (keyval >= '0' && keyval <= '9');
    if (isnum)
    {
      value = value * 10 + keyval - '0';
    }

  } while (isnum || !keyval);
  return value;

}


int printit(int X[], int p) {
  for ( int j = 0; j < p; ++j ) {
    Serial.print (X[j]) ;
  }
  Serial.println(" ");
}


int swap(int Q[],int e,int r){
    int temp = Q[e];
    Q[e] =  Q[r];
    Q[r] = temp;
}


long int IDK(int qwe[]) {
  long int ABC = 0;
  for (int i = 0; i < MAX;i = i + 1) {
    ABC = (ABC * 2) + qwe[i];
  }
  return ABC;
}

void clr (int ABV[]){
  for(int qwert = 0; qwert < MAX; ++qwert){
    ABV[qwert] = 0;
  }
}

